//---------------------------------------------------------------------------

#ifndef BoardH
#define BoardH
//---------------------------------------------------------------------------

typedef SmartPtr<CardStack> StackPtr;
typedef vector<StackPtr> vstack;

enum BoardArea {TableauArea, FoundationArea, StockArea, ReserveArea,
                WastepileArea, RemoveArea, AnyArea};
enum OrderType {AltColor=0x01,
                SameColor=0x02,
                SameSuit=0x04,
                AnySuit=0x08,
                AnyCard=0x10,
                Rank=0x20,
                Ascending=0x40,
                Descending=0x80};
enum MoveType  {Any=0x01,
                FullStack=0x02,
                ValidStack=0x04,
                SingleCard=0x08,
                ThroughReserve=0x10,
                OnBlank=0x20};
enum FinishType {TableauEmpty,AllInFoundation,SingleStack};

struct MoveRule
{
    int  move;
    int  dest;
    int  source;
    int  order;
    int  rank;
    int  count;
    bool validate;
};

typedef vector<MoveRule> vmove;

class Board
{
    protected:
    vstack Tableau, Foundation, Reserve;
    vstack All;
    StackPtr Move, MoveSrc, Stock, Wastepile, Remove;
    CardsInterface *m_ci;
    vmove moves;
    int finish;

    StackPtr MapMouse(int x, int y);
    bool ValidateMove(StackPtr dest);
    int GetArea(StackPtr ptr);
    bool ValidateCards(CardPtr c1, CardPtr c2, int area);

    public:
    Board();
    virtual ~Board();
    virtual void Draw(HDC dc);
    virtual void Deal();
    virtual void InitGame();
    bool OnMouseDown(int button, int x, int y);
    bool OnMouseUp(int button, int x, int y);
    bool OnMouseMove(int x, int y);
    void Clear();
    bool CheckFinish();

};

#endif
