//---------------------------------------------------------------------------

#ifndef CardH
#define CardH
//---------------------------------------------------------------------------

class Card
{
    int m_rank,m_suit,m_back,m_color;
    bool m_faceup;
    CardsInterface *m_ci;

    public:
    enum Colors {black,red};

    Card(int rank,int suit);
    Card();
    ~Card();
    
    int GetRank() {return m_rank;}
    int GetSuit() {return m_suit;}
    bool GetFaceDown() {return !m_faceup;} 
    int GetColor();
    int GetDllCode() {return (m_rank*4+m_suit);}

    void Draw(HDC dc, int x, int y);
    void SetFaceUp() {m_faceup=true;}
    void SetFaceDown() {m_faceup=false;}
    void SetBack(int pattern,int color=0);

    Card GetHigher();
    Card GetLower();

    bool operator==(Card &c);
    bool operator!=(Card &c);
    bool operator<(Card &c);
    bool operator<=(Card &c);
    bool operator>(Card &c);
    bool operator>=(Card &c);

    Card& operator=(Card &c);
    Card& operator=(Card c);

};

#endif
