//---------------------------------------------------------------------------

#ifndef CardsInterfaceH
#define CardsInterfaceH

#include <windows.h>
//#pragma hdrstop

class CardsInterface
{
    protected:
    int width,height;

    public:
    virtual bool Init()=0;
    virtual bool Draw(HDC, int x, int y, int card, int type, DWORD color)=0;
    virtual bool DrawEx(HDC, int x, int y, int dx, int dy, int card, int type, DWORD color)=0;
    virtual bool Animate(HDC hdc, int cardback, int x, int y, int frame)=0;
    virtual void Term()=0;

    int GetWidth()  {return width;}
    int GetHeight() {return height;}
};

class CardsInterface16 : public CardsInterface
{
    public:

    bool Init();
    bool Draw(HDC hdc, int x, int y, int card, int type, DWORD color);
    bool DrawEx(HDC hdc, int x, int y, int dx, int dy, int card, int type, DWORD color);
    bool Animate(HDC hdc, int cardback, int x, int y, int frame);
    void Term();

};


typedef BOOL (WINAPI *pfcdtInit)(int *, int *);
typedef BOOL (WINAPI *pfcdtDraw)(HDC hdc, int x, int y, int card, int type, DWORD color);
typedef BOOL (WINAPI *pfcdtDrawEx)(HDC hdc, int x, int y, int dx, int dy, int card, int type, DWORD color);
typedef BOOL (WINAPI *pfcdtAnimate)(HDC hdc, int cardback, int x, int y, int frame);
typedef void (WINAPI *pfcdtTerm) (void);

class CardsInterface32 : public CardsInterface
{
    pfcdtInit		cdtInit;
    pfcdtDraw		cdtDraw;
    pfcdtDrawEx		cdtDrawEx;
    pfcdtAnimate	cdtAnimate;
    pfcdtTerm		cdtTerm;
    HINSTANCE       dll;

    public:

    bool Init();
    bool Draw(HDC, int x, int y, int card, int type, DWORD color);
    bool DrawEx(HDC, int x, int y, int dx, int dy, int card, int type, DWORD color);
    bool Animate(HDC hdc, int cardback, int x, int y, int frame);
    void Term();
};

CardsInterface* GetCardsInterface();

//---------------------------------------------------------------------------
#endif
