//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "stdinclude.h"
#include "Klondike.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void Klondike::Deal()
{
    int i,j,k;
    CardPtr c;
    //SmartPtr<CardStack> tmp;
    CardPtr deck[52];

    for (i=0;i<13;i++)
        for (j=0;j<4;j++)
        {
            c=new Card(i,j);
            deck[i*4+j]=c;
        }

    // shuffle
    randomize();
    for (j=0;j<4;j++)
        for (i=0;i<51;i++)
        {
            k=random(52-i)+i;
            c=deck[k];
            deck[k]=deck[i];
            deck[i]=c;
        }

    k=0;
    for (i=0;i<7;i++)
        for (j=i;j<7;j++)
        {
            c=deck[k++];
            /*
            if (i==j)
                c->SetFaceUp();
            else
                c->SetFaceDown();
            */
            c->SetBack(63,0);
            Tableau[j]->AddCard(c);
        }

    while (k<52)
    {
        c=deck[k++];
        c->SetFaceDown();
        Stock->AddCard(c);
    }
    for (i=0;i<52;i++)
        deck[i]=0;
}

void Klondike::InitGame()
{
    StackPtr tmp;
    int i,hspace,vspace;

    hspace=m_ci->GetWidth()*1.1;
    vspace=m_ci->GetHeight()*1.2;
    for (i=0;i<7;i++)
    {
        tmp=new DropStack(50+hspace*i,20+vspace);
        Tableau.push_back(tmp);
        All.push_back(tmp);
    }
    tmp=new TopStack(50,20);
    tmp->SetFaceDown();
    Stock=tmp;
    All.push_back(tmp);

    tmp=new TopStack(50+hspace,20);
    tmp->SetFaceUp();
    Wastepile=tmp;
    All.push_back(tmp);

    for (i=0;i<4;i++)
    {
        tmp=new TopStack(50+hspace*(i+3),20);
        Foundation.push_back(tmp);
        All.push_back(tmp);
    }
    Move=new DropStack(1,1);
    finish=AllInFoundation;

    MoveRule rule;

    rule.move=ValidStack;
    rule.dest=TableauArea;
    rule.source=AnyArea;
    rule.order=AltColor | Descending;
    rule.rank=0;
    rule.validate=true;
    moves.push_back(rule);

    rule.move=ValidStack | OnBlank;
    rule.order=Rank;
    rule.rank=12;
    moves.push_back(rule);

    rule.dest=FoundationArea;
    rule.move=SingleCard;
    rule.order=SameSuit | Ascending;
    moves.push_back(rule);

    rule.move=SingleCard | OnBlank;
    rule.order=Rank;
    rule.rank=0;
    moves.push_back(rule);

    rule.dest=WastepileArea;
    rule.source=StockArea;
    rule.move=Any;
    rule.count=3;
    rule.order=AnyCard;
    moves.push_back(rule);

    rule.dest=StockArea;
    rule.source=WastepileArea;
    rule.move=FullStack | OnBlank;
    moves.push_back(rule);
}

