//---------------------------------------------------------------------------

#ifndef StackH
#define StackH
//---------------------------------------------------------------------------

typedef vector<SmartPtr<Card> > vcards;
typedef SmartPtr<Card> CardPtr;

class CardStack
{
    protected:
    vcards m_list;
    int m_x,m_y;
    bool m_facedown;
    void DrawOutline(HDC dc);

    public:
    CardStack(int x,int y);
    virtual ~CardStack();

    void SetFaceDown() {m_facedown=true;}
    void SetFaceUp() {m_facedown=false;}
    virtual bool AddCard(CardPtr c);
    virtual bool AddCards(vcards cards);
    virtual vcards RemoveCards(unsigned int n);
    bool Contains(CardPtr c);
    CardPtr GetTop();
    virtual void Draw(HDC dc)=0;
    bool isEmpty();
    virtual bool isFull();
    virtual TRect GetSize()=0;
    virtual bool ContainsPoint(int x, int y);
    void SetPos(int x, int y);
    int GetNum();
    virtual void UpdateStack()=0;
    virtual int GetSelectCount(int x, int y)=0;
    CardPtr GetBottom();
    CardPtr GetAt(unsigned int pos);
    void ReverseOrder();
    void Clear();
    TRect GetRect();

};

class DropStack : public CardStack
{
    int vspace;
    
    public:
    DropStack(int x,int y);
    virtual void Draw(HDC dc);
    virtual TRect GetSize();
    virtual void UpdateStack();
    virtual int GetSelectCount(int x, int y);
};

class TopStack : public CardStack
{
    public:
    TopStack(int x,int y);
    virtual void Draw(HDC dc);
    virtual TRect GetSize();
    virtual void UpdateStack();
    virtual int GetSelectCount(int x, int y);
};

#endif
