//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "CardsInterface.h"
#include "Card.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)


Card::Card(int rank,int suit)
{
    m_rank=rank;
    m_suit=suit;
    m_back=63;
    m_color=0;
    m_faceup=true;
    m_ci=GetCardsInterface();
}

Card::Card()
{
    m_rank=0;
    m_suit=0;
    m_back=63;
    m_color=0;
    m_faceup=true;
    m_ci=GetCardsInterface();
}

Card::~Card()
{
    //int i=0;
}

int Card::GetColor()
{
    if (m_suit==0 || m_suit==3)
        return black;
    return red;
}

void Card::Draw(HDC dc, int x, int y)
{
    if (m_faceup)
        m_ci->Draw(dc,x,y,GetDllCode(),0,0);
    else
        m_ci->Draw(dc,x,y,m_back,1,m_color);
}

void Card::SetBack(int pattern,int color)
{
    if (pattern>=53 && pattern<=65)
    {
        m_back=pattern;
        m_color=color;
    }
}

bool Card::operator==(Card& c)
{
    return (m_rank==c.m_rank && m_suit==c.m_suit);
}
bool Card::operator!=(Card& c)
{
    return (m_rank!=c.m_rank || m_suit!=c.m_suit);
}
bool Card::operator<(Card& c)
{
    return (m_rank<c.m_rank);
}
bool Card::operator<=(Card& c)
{
    return (m_rank<c.m_rank || *this==c);
}
bool Card::operator>(Card& c)
{
    return (m_rank>c.m_rank);
}
bool Card::operator>=(Card& c)
{
    return (m_rank>c.m_rank || *this==c);
}

Card& Card::operator=(Card &c)
{
    if (this==&c)
        return *this;
    m_rank=c.m_rank;
    m_suit=c.m_suit;
    m_back=c.m_back;
    m_color=c.m_color;
    m_faceup=c.m_faceup;
    m_ci=c.m_ci;
    return *this;
}

Card& Card::operator=(Card c)
{
    if (this==&c)
        return *this;
    m_rank=c.m_rank;
    m_suit=c.m_suit;
    m_back=c.m_back;
    m_color=c.m_color;
    m_faceup=c.m_faceup;
    m_ci=c.m_ci;
    return *this;
}

Card Card::GetHigher()
{
    Card c=*this;
    c.m_rank=(c.m_rank+1)%13;
    return c;
}

Card Card::GetLower()
{
    Card c=*this;
    c.m_rank--;
    if (c.m_rank<0)
        c.m_rank=12;
    return c;
}
